﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PM02
{
    public class Program
    {
        static void Main(string[] args)
        {
            TextWriterTraceListener tr2 = new TextWriterTraceListener(System.IO.File.CreateText(@"../../Output.txt"));
            Debug.Listeners.Add(tr2);
            Dictionary<double,double> money = new Dictionary<double, double>();
            for (int i = 0; i <= 1000000; i+= 10000)
            {
                User user = new User();
                double percentBet = 1;
                double bankBet = 8;
                user.investment = i;
                user.deposit = user.investment;
                double currentDeposit = user.investment;
                double monthIncome = 0;
                double yearIncome = 0;
                int month = 1;
                int year = 2022;
                while (currentDeposit < 1000000)
                {
                    if (percentBet > bankBet)
                        currentDeposit *= percentBet;

                    if (currentDeposit < 700000)
                    {
                        percentBet = Math.Round(currentDeposit) / 50000 + 1;
                    }
                    else
                    {
                        int tmp = (int)currentDeposit - 700000;
                        percentBet = 20 - tmp / 50000;
                    }
                    if (currentDeposit == 700000)
                        percentBet = 20;
                    if (month % 3 == 0)
                        IncreaseBet(percentBet, 0.5);

                    currentDeposit += currentDeposit * (percentBet / 100);
                    monthIncome = currentDeposit - user.deposit;
                    if (percentBet > bankBet && percentBet - bankBet >= 5)
                        currentDeposit -= GetTax(monthIncome);
                    month++;
                    Console.WriteLine("Баланс: {0} / {1}%", Math.Round(currentDeposit, 2), Math.Round(percentBet));
                    if (month == 13)
                    {
                        yearIncome = currentDeposit - user.deposit;
                        month = 0;
                        year++;
                        Debug.WriteLine("Баланс: {0}. За год {1} / {2}%", Math.Round(currentDeposit, 2), Math.Round(yearIncome, 2), Math.Round(percentBet));
                        user.deposit = currentDeposit;
                        
                        break;
                    }
                }
                money.Add(user.investment,currentDeposit);
            }
            foreach (var item in money.OrderByDescending(value => value.Value))
            {

            }
            Debug.WriteLine($"Максимальный доход {money.Keys.First()} начался с {money.Values.First()}");
            Debug.Flush();
            Console.ReadLine();
        }
        static double IncreaseBet(double bet, double count) => bet += count;
        public static double GetTax(double deposit) => deposit *= 0.0;
    }

    public class User
    {
        public double investment { get; set; }
        public double deposit { get; set; }
        public double bet { get; set; }
    }
}
